<?php
/*
  $Id$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2016 osCommerce

  Released under the GNU General Public License
*/

  class cm_forms_recaptcha {
	var $version = '1.2';
	var $code;
    var $group;
    var $title;
    var $description;
    var $enabled = false;

    function __construct() {
      global $PHP_SELF;
	  
      $this->code = get_class($this);
      $this->group = basename(dirname(__FILE__));

      $this->title = MODULE_CONTENT_RECAPTCHA_TITLE;
      $this->description = MODULE_CONTENT_RECAPTCHA_DESCRIPTION;
      $this->description .= '<div class="secWarning">' . MODULE_CONTENT_BOOTSTRAP_ROW_DESCRIPTION . '</div>';
						   
      if ( defined('MODULE_CONTENT_RECAPTCHA_STATUS') ) {
        $this->enabled = (MODULE_CONTENT_RECAPTCHA_STATUS == 'True');		
      }

      if ($this->enabled == 'True') {
	 	 if (tep_not_null(MODULE_CONTENT_RECAPTCHA_PAGES)) {
           $pages_array = array();
            
			foreach (explode(';', MODULE_CONTENT_RECAPTCHA_PAGES) as $page) {
              $page = trim($page);
              if (!empty($page)) {
                $pages_array[] = $page;
              }
            }
			
            if (!in_array(basename($PHP_SELF), $pages_array)) {
              $this->enabled = (MODULE_CONTENT_RECAPTCHA_STATUS == 'False');		
            }
	 	 }
      } // end if ($this->enabled == 'True')
	  
    }

    function execute() {
      global $oscTemplate, $PHP_SELF;
	  
   // aado los js y css
 	 	 if (tep_not_null(MODULE_CONTENT_RECAPTCHA_PAGES)) {
           $pages_array = array();
            
			foreach (explode(';', MODULE_CONTENT_RECAPTCHA_PAGES) as $page) {
              $page = trim($page);
              if (!empty($page)) {
                $pages_array[] = $page;
              }
            }
			
            if (in_array(basename($PHP_SELF), $pages_array)) {
                  $header_tags = ' <script>
  var onloadCallback = function() {
   grecaptcha.render(\'g-recaptcha\', {
    \'sitekey\' : \'' . MODULE_CONTENT_RECAPTCHA_PUBLIC_KEY.'\',
    \'theme\' : \'' . MODULE_CONTENT_RECAPTCHA_THEME.'\',
    \'size\' : \'' . MODULE_CONTENT_RECAPTCHA_SIZE.'\'
   });
  };
 </script>' . PHP_EOL;
                 $header_tags .= ' <script src="https://www.google.com/recaptcha/api.js?onload=onloadCallback&render=explicit" async defer></script>' . PHP_EOL;
                 $header_tags .= ' <style>
   @media screen and (max-width: 382px) {
   /* this will cut that box in half though without the reCAPTCHA logo. */
   #g-recaptcha { width:160px; border-radius:4px; border-right:1px solid #d8d8d8; overflow:hidden; }
  }
 </style>' . PHP_EOL;

                $oscTemplate->addBlock($header_tags, 'footer_scripts');
            }
	 	 }
   // fin aado los js y css

	  $content_width = MODULE_CONTENT_RECAPTCHA_CONTENT_WIDTH;

	  // remove any leading and trailing spaces from entered API keys
	  str_replace(' ', '', MODULE_CONTENT_RECAPTCHA_PUBLIC_KEY);
	  str_replace(' ', '', MODULE_CONTENT_RECAPTCHA_PRIVATE_KEY);
      	  
      ob_start();
      include('includes/modules/content/' . $this->group . '/templates/recaptcha.php');
      $template = ob_get_clean(); 
        
      $oscTemplate->addContent($template, $this->group);
    }

    function isEnabled() {
      return $this->enabled;
    }

    function check() {
      return defined('MODULE_CONTENT_RECAPTCHA_STATUS');
    }

    function install() {
	  if ( !defined('RECAPTCHA_MODULE') ) {
		  define('MODULE_CONTENT_RECAPTCHA_PUBLIC_KEY', 'Enter your public key');
		  define('MODULE_CONTENT_RECAPTCHA_PRIVATE_KEY', 'Enter your private key');

	  tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Current Version', 'RECAPTCHA_MODULE', 'reCAPTCHA-2 BS v" . $this->version . "', 'Creates a reCAPTCHA-2 validation for forms on the pages you select.', '6', '0', 'tep_version_readonly(', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable reCAPTCHA-2 Validation Module', 'MODULE_CONTENT_RECAPTCHA_STATUS', 'True', 'Do you want to enable this module? For this module to work, you must first get your API keys from https://www.google.com/recaptcha/admin/', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
	  tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added, use_function, set_function) values ('Public Key', 'MODULE_CONTENT_RECAPTCHA_PUBLIC_KEY', '" . tep_db_input(MODULE_CONTENT_RECAPTCHA_PUBLIC_KEY) . "', 'Enter your reCAPTCHA Public Key.', '6', '2', NOW(), null, null)");
	  tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added, use_function, set_function) values ('Private Key', 'MODULE_CONTENT_RECAPTCHA_PRIVATE_KEY', '" . tep_db_input(MODULE_CONTENT_RECAPTCHA_PRIVATE_KEY) . "', 'Enter your reCAPTCHA Private Key.', '6', '3', NOW(), null, null)");

      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Theme', 'MODULE_CONTENT_RECAPTCHA_THEME', 'light', 'Please select the theme for your reCAPTCHA.', '6', '15', 'tep_cfg_select_option(array(\'light\', \'dark\'), ', now())");
	  tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Size', 'MODULE_CONTENT_RECAPTCHA_SIZE', 'normal', 'Please select the size of your reCAPTCHA box.', '6', '16', 'tep_cfg_select_option(array(\'normal\', \'compact\'), ', now())");
	  tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Position', 'MODULE_CONTENT_RECAPTCHA_POSITION', 'pull-right', 'Where would you like the reCAPTCHA displayed?', '6', '17', 'tep_cfg_select_option(array(\'pull-left\', \'center-block\', \'pull-right\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Pages', 'MODULE_CONTENT_RECAPTCHA_PAGES', '" . implode(';', $this->get_default_pages()) . "', 'The pages to add the Recaptcha to.', '6', '0', 'cm_recaptcha_show_pages', 'cm_recaptcha_edit_pages(', now())");
	  tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Content Width', 'MODULE_CONTENT_RECAPTCHA_CONTENT_WIDTH', '12', 'What width container should the content be shown in? (12 = full width, 6 = half width).', '6', '18', 'tep_cfg_select_option(array(\'12\', \'11\', \'10\', \'9\', \'8\', \'7\', \'6\', \'5\', \'4\', \'3\', \'2\', \'1\'), ', now())");
	  } // if ( !defined('RECAPTCHA_MODULE') )
    }

    function remove() {
      tep_db_query("delete from configuration where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('RECAPTCHA_MODULE', 
	  			   'MODULE_CONTENT_RECAPTCHA_STATUS', 
				   'MODULE_CONTENT_RECAPTCHA_PUBLIC_KEY', 
				   'MODULE_CONTENT_RECAPTCHA_PRIVATE_KEY', 
				   'MODULE_CONTENT_RECAPTCHA_THEME', 
				   'MODULE_CONTENT_RECAPTCHA_SIZE', 
				   'MODULE_CONTENT_RECAPTCHA_POSITION', 
				   'MODULE_CONTENT_RECAPTCHA_PAGES',
				   'MODULE_CONTENT_RECAPTCHA_CONTENT_WIDTH');
    }
	
    function get_default_pages() {
      return array('login.php', 
                   'create_account.php', 
                   'account_pwa.php', 
                   'account_edit.php', 
                   'account_password.php', 
                   'password_forgotten.php', 
                   'contact_us.php', 
                   'tell_a_friend.php', 
                   'product_reviews_write.php', 
                   'product_reviews_write_pwa.php');
    }
  }

  function cm_recaptcha_show_pages($text) {
    return nl2br(implode("\n", explode(';', $text)));
  }

  function cm_recaptcha_edit_pages($values, $key) {
    global $PHP_SELF;

    $file_extension = substr($PHP_SELF, strrpos($PHP_SELF, '.'));
    $files_array = array();
	  if ($dir = @dir(DIR_FS_CATALOG)) {
	    while ($file = $dir->read()) {
	      if (!is_dir(DIR_FS_CATALOG . $file)) {
	        if (substr($file, strrpos($file, '.')) == $file_extension) {
            $files_array[] = $file;
          }
        }
      }
      sort($files_array);
      $dir->close();
    }

    $values_array = explode(';', $values);

    $output = '';
    foreach ($files_array as $file) {
      $output .= tep_draw_checkbox_field('cm_recaptcha_file[]', $file, in_array($file, $values_array)) . '&nbsp;' . tep_output_string($file) . '<br />';
    }

    if (!empty($output)) {
      $output = '<br />' . substr($output, 0, -6);
    }

    $output .= tep_draw_hidden_field('configuration[' . $key . ']', '', 'id="htrn_files"');

    $output .= '<script>
                function htrn_update_cfg_value() {
                  var htrn_selected_files = \'\';

                  if ($(\'input[name="cm_recaptcha_file[]"]\').length > 0) {
                    $(\'input[name="cm_recaptcha_file[]"]:checked\').each(function() {
                      htrn_selected_files += $(this).attr(\'value\') + \';\';
                    });

                    if (htrn_selected_files.length > 0) {
                      htrn_selected_files = htrn_selected_files.substring(0, htrn_selected_files.length - 1);
                    }
                  }

                  $(\'#htrn_files\').val(htrn_selected_files);
                }

                $(function() {
                  htrn_update_cfg_value();

                  if ($(\'input[name="cm_recaptcha_file[]"]\').length > 0) {
                    $(\'input[name="cm_recaptcha_file[]"]\').change(function() {
                      htrn_update_cfg_value();
                    });
                  }
                });
                </script>';

    return $output;
  }
  // Function for version read only
  if (!function_exists('tep_version_readonly')) {
        function tep_version_readonly($value){
          $version_text = $value;
          return $version_text;
        }
  }
